<template>
    <div class="mapholder" v-show="coord"></div>
</template>

<script>
    import gMapInit from '../../utils/gMap'

    export default {
        name: "GMap",
        props: {
            coord: {
                type: Object
            },
        },
        data() {
            return {
                google: null,
                map: null,
                marker: null
            }
        },
        watch: {
            coord(coord) {
                const position = {lat: coord.lat, lng: coord.lon};
                this.map.setCenter(position);
                this.marker.setPosition(position);
            }
        },
        async mounted() {
            this.google = await gMapInit();
            const position = {lat: +this.coord.lat.toFixed(1), lng: +this.coord.lon.toFixed(1)};
            this.map = new this.google.maps.Map(this.$el, {
                zoom: 5,
                center: position
            });
            this.marker = new this.google.maps.Marker({position,map: this.map});

            this.map.addListener('click', (e) => {
                console.log(e);
                const coord = {lat: +e.latLng.lat().toFixed(1), lng: +e.latLng.lng().toFixed(1)};
                let index = 0;
                while(+coord.lat.toFixed(1) !== +position.lat.toFixed(1) || +coord.lng.toFixed(1) !== +position.lng.toFixed(1)) {
                    position.lat = coord.lat === position.lat ? coord.lat :
                        coord.lat > position.lat ? +(position.lat+0.1).toFixed(1) : +(position.lat-0.1).toFixed(1);

                    position.lng = coord.lng === position.lng ? coord.lng :
                        coord.lng > position.lng ? +(position.lng+0.1).toFixed(1) : +(position.lng-0.1).toFixed(1);

                    index++;
                    let indexLoc = JSON.parse(JSON.stringify(index));
                    let positionLoc = JSON.parse(JSON.stringify(position));
                    const speed = 50;
                    setTimeout(() => {
                        this.map.setCenter(positionLoc);
                        this.marker.setPosition(positionLoc);
                    }, 100/speed*indexLoc);
                }
                this.$emit('changeCoord', coord);
            });
        },
    }
</script>

<style scoped lang="scss">
    .mapholder {
        height: 300px;
        opacity: .5;
    }
</style>